
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

    <title>Wanton destruction for the greater good &#8212; Varnish version 6.0.11 documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/classic.css" />
    
    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="What SPDY did to my summer vacation" href="spdy.html" />
    <link rel="prev" title="Raking in the dough on Free and Open Source Software" href="dough.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="spdy.html" title="What SPDY did to my summer vacation"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="dough.html" title="Raking in the dough on Free and Open Source Software"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">Poul-Hennings random outbursts</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Wanton destruction for the greater good</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <section id="wanton-destruction-for-the-greater-good">
<span id="phk-wanton"></span><h1>Wanton destruction for the greater good<a class="headerlink" href="#wanton-destruction-for-the-greater-good" title="Permalink to this headline">¶</a></h1>
<p>We live in an old house, and it’s all wrong for us.</p>
<p>When I bought this house, it was perfect, or at least perfect enough.</p>
<p>But times have changed.</p>
<p>I have no small kids anymore, and rather than just right for two
kids to tumble in, the garden is now too small for all the flowers
we want.</p>
<p>And the rooms are not where we want them, there are too many stairs
in all the wrong places, and the kitchen needs to be torn out and
a new built.</p>
<p>I’m sure that some other family will be able to fall in love with
this house, the way we did, but there is no realistic way to
rebuild it, to become the house we want now.</p>
<p>For one thing, doing major surgery on a house while you live in it
is double-minus-fun and it always slows the rebuild project down
when you have to keep at least one toilet working and sanitary and
be able to cook and sleep on the building site.</p>
<p>So we’ll be building a new house on a plot of land on the other
side of the road, one of the coming years, a house which is right
for us, and then we will sell this old house, to a family with small
children, who will love it, and rip out the old funky kitchen and
make a new one before they move in.</p>
<p>One would think that software would be nothing like an old house,
but they are more alike than most people imagine.</p>
<p>Using a major piece of software, is like moving into a house: You
need to adapt your life and the house or the software to each other,
since nothing is ever quite perfect, there will be limitations.</p>
<p>And those limitations affect how you think:  If you live in a
2 bedroom apartment, you won’t even be considering inviting 80
guests to a party.</p>
<p>A lot of Varnish-users have taken time to figure out how Varnish
fits into their lives and made the compromises necessary to make
it work, and once you’ve done that, you moved on to other problems,
but the limitations of Varnish keeps affecting how you think about
your website, even if you don’t realize this.</p>
<p>Well, I’ve got news for you:  You’ll be moving into a new house in
the next couple of years, it’ll be called Varnish V4 and that means
that you will have to decide who gets which room and where to store
the towels and grandmothers old china, all over again.</p>
<p>I’m sure you’ll hate me for it, “Why do we have to move ?”, “It
really wasn’t that bad after all” and so on and so forth.
But if I do my job right, that will soon turn into “Ohh, that’s
pretty neat, I always wanted one of those…” and “Hey… Watch me
do THIS!” etc.</p>
<p>I could have started with a fresh GIT repository, to make it clear
that what is happening right now is the construction of an entirely
new house, but software isn’t built from physical objects, so I
don’t need to do that:  You can keep using Varnish, while I rebuild
it, and thanks to the wonder of bits, you won’t see a trace of
dirt or dust while it happens.</p>
<p>So don’t be alarmed by the wanton destruction you will see in -trunk
the coming weeks, it is not destroying the Varnish you are using
for your website today, it is building the new one you will be using
in the future.</p>
<p>And it’s going to be perfect for you, at least for some years…</p>
<p>Poul-Henning, 2013-03-18</p>
</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="dough.html"
                        title="previous chapter">Raking in the dough on Free and Open Source Software</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="spdy.html"
                        title="next chapter">What SPDY did to my summer vacation</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../_sources/phk/wanton_destruction.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="spdy.html" title="What SPDY did to my summer vacation"
             >next</a> |</li>
        <li class="right" >
          <a href="dough.html" title="Raking in the dough on Free and Open Source Software"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" >Poul-Hennings random outbursts</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Wanton destruction for the greater good</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2010-2014, Varnish Software AS.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 4.3.2.
    </div>
  </body>
</html>